# 
# Copyright (C) 2003 Carl Johan Lejdfors
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 
# Please send all bugreports to: Carl Johan Lejdfors <calle.lejdfors@cs.lth.se>
# 


from Cg import *
import OpenGL.GL
from OpenGL.GL.NV.texture_rectangle import *

# Seems that PyOpenGL doesn't define these.
GL_TEXTURE_CUBE_MAP_EXT = 0x8513
GL_TEXTURE_CUBE_MAP_ARB = 0x8513
GL_NORMAL_MAP_ARB = 0x8511
GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB = 0x8515
GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB = 0x8516
GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB = 0x8517
GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB = 0x8518
GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB = 0x8519
GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB = 0x851A
GL_CLAMP_TO_EDGE = 0x812F
GL_TEXTURE_WRAP_R = 0x8072
##GL_TEXTURE_RECTANGLE_NV = 0x84F5


GL_RGBA_FLOAT32_ATI                 = 0x8814
GL_RGB_FLOAT32_ATI                  = 0x8815
GL_ALPHA_FLOAT32_ATI                = 0x8816
GL_INTENSITY_FLOAT32_ATI            = 0x8817
GL_LUMINANCE_FLOAT32_ATI            = 0x8818
GL_LUMINANCE_ALPHA_FLOAT32_ATI      = 0x8819
GL_RGBA_FLOAT16_ATI                 = 0x881A
GL_RGB_FLOAT16_ATI                  = 0x881B
GL_ALPHA_FLOAT16_ATI                = 0x881C
GL_INTENSITY_FLOAT16_ATI            = 0x881D
GL_LUMINANCE_FLOAT16_ATI            = 0x881E
GL_LUMINANCE_ALPHA_FLOAT16_ATI      = 0x881F

GL_FLOAT_R_NV                       = 0x8880
GL_FLOAT_RG_NV                      = 0x8881
GL_FLOAT_RGB_NV                     = 0x8882
GL_FLOAT_RGBA_NV                    = 0x8883
GL_FLOAT_R16_NV                     = 0x8884
GL_FLOAT_R32_NV                     = 0x8885
GL_FLOAT_RG16_NV                    = 0x8886
GL_FLOAT_RG32_NV                    = 0x8887
GL_FLOAT_RGB16_NV                   = 0x8888
GL_FLOAT_RGB32_NV                   = 0x8889
GL_FLOAT_RGBA16_NV                  = 0x888A
GL_FLOAT_RGBA32_NV                  = 0x888B


##
ADD = 1
SUBTRACT = 2
REVSUBTRACT = 3
MIN = 4
MAX = 5


CCW = OpenGL.GL.GL_CCW
CW  = OpenGL.GL.GL_CW

NEVER = OpenGL.GL.GL_NEVER
LESS  = OpenGL.GL.GL_LESS
EQUAL = OpenGL.GL.GL_EQUAL
LESSEQUAL = OpenGL.GL.GL_LEQUAL
GREATER = OpenGL.GL.GL_GREATER
NOTEQUAL = OpenGL.GL.GL_NOTEQUAL
GREATEREQUAL = OpenGL.GL.GL_GEQUAL
ALWAYS = OpenGL.GL.GL_ALWAYS

POINT = OpenGL.GL.GL_POINT
WIREFRAME = OpenGL.GL.GL_LINE
SOLID = OpenGL.GL.GL_FILL

FLAT = OpenGL.GL.GL_FLAT
GOURAUD = OpenGL.GL.GL_SMOOTH
PHONG = OpenGL.GL.GL_SMOOTH

ZERO = OpenGL.GL.GL_ZERO
ONE = OpenGL.GL.GL_ONE
SRCCOLOR = OpenGL.GL.GL_SRC_COLOR
INVSRCCOLOR = OpenGL.GL.GL_ONE_MINUS_SRC_COLOR
SRCALPHA = OpenGL.GL.GL_SRC_ALPHA
INVSRCALPHA = OpenGL.GL.GL_ONE_MINUS_SRC_ALPHA
DESTALPHA = OpenGL.GL.GL_DST_ALPHA
INVDESTALPHA = OpenGL.GL.GL_ONE_MINUS_DST_ALPHA
DESTCOLOR = OpenGL.GL.GL_DST_COLOR
INVDESTCOLOR = OpenGL.GL.GL_ONE_MINUS_DST_COLOR
SRCALPHASAT = None ## OpenGL.GL.GL_
BOTHSRCALPHA = None ## OBSOLETE: OpenGL.GL.GL_SRC_ALPHA
BOTHINVSRCALPHA = OpenGL.GL.GL_ONE_MINUS_SRC_ALPHA
BLENDFACTOR = None ## OpenGL.GL.GL_
INVBLENDFACTOR = None ## OpenGL.GL.GL_

# NV_texture_env_combine4
COMBINE4 = 0x8503
SOURCE0_RGB_NV = 0x8580
SOURCE1_RGB_NV = 0x8581
SOURCE2_RGB_NV = 0x8582
SOURCE3_RGB_NV = 0x8583
SOURCE3_ALPHA_NV = 0x8588
SOURCE3_ALPHA_NV = 0x8589
SOURCE3_ALPHA_NV = 0x858A
SOURCE3_ALPHA_NV = 0x858B
OPERAND0_RGB_NV = 0x8590
OPERAND1_RGB_NV = 0x8591
OPERAND2_RGB_NV = 0x8592
OPERAND3_RGB_NV = 0x8593
OPERAND0_ALPHA_NV = 0x8598
OPERAND1_ALPHA_NV = 0x8599
OPERAND2_ALPHA_NV = 0x859A
OPERAND3_ALPHA_NV = 0x859B

BACK = OpenGL.GL.GL_BACK
FRONT = OpenGL.GL.GL_FRONT


KEEP = OpenGL.GL.GL_KEEP
ZERO = OpenGL.GL.GL_ZERO
REPLACE = OpenGL.GL.GL_REPLACE
INVERT = OpenGL.GL.GL_INVERT
INCR = OpenGL.GL.GL_INCR
DECR = OpenGL.GL.GL_DECR
TWOSIDED = None ## OpenGL.GL.GL_
INCRSAT = INCR ## None ## OpenGL.GL.GL_
DECRSAT = DECR ## None ## OpenGL.GL.GL_

EXP = OpenGL.GL.GL_EXP
EXP2 = OpenGL.GL.GL_EXP2
LINEAR = OpenGL.GL.GL_LINEAR

## Texture types 
TEXTURE_1D = OpenGL.GL.GL_TEXTURE_1D
TEXTURE_2D = OpenGL.GL.GL_TEXTURE_2D
TEXTURE_3D = 0x806F
TEXTURE_CUBE = GL_TEXTURE_CUBE_MAP_ARB
TEXTURE_RECT = GL_TEXTURE_RECTANGLE_NV

## Texture parameters
CLAMP = OpenGL.GL.GL_CLAMP
REPEAT = OpenGL.GL.GL_REPEAT
CLAMP_TO_EDGE = GL_CLAMP_TO_EDGE

## Texture filtering
NEAREST = OpenGL.GL.GL_NEAREST
LINEAR = OpenGL.GL.GL_LINEAR
POINT = OpenGL.GL.GL_NEAREST

## TexGen parameters
OBJECT_LINEAR = OpenGL.GL.GL_OBJECT_LINEAR
NORMAL_MAP = GL_NORMAL_MAP_ARB

## Clear stuff
COLOR_BUFFER = OpenGL.GL.GL_COLOR_BUFFER_BIT
DEPTH_BUFFER = OpenGL.GL.GL_DEPTH_BUFFER_BIT
ACCUM_BUFFER = OpenGL.GL.GL_ACCUM_BUFFER_BIT
STENCIL_BUFFER = OpenGL.GL.GL_STENCIL_BUFFER_BIT
