
#======================================================================================#
# Copyright (C) 2004 Carl Johan Lejdfors                                               #
#                                                                                      #
# This program is free software; you can redistribute it and/or modify                 #
# it under the terms of the GNU General Public License as published by                 #
# the Free Software Foundation; either version 2 of the License, or                    #
# (at your option) any later version.                                                  #
#                                                                                      #
# This program is distributed in the hope that it will be useful,                      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                        #
# GNU General Public License for more details.                                         #
#                                                                                      #
# You should have received a copy of the GNU General Public License                    #
# along with this program; if not, write to the Free Software                          #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            #
#                                                                                      #
# Please send all bugreports to: Carl Johan Lejdfors <calle.lejdfors@cs.lth.se>        #
#======================================================================================#


import FX
from FX.util import marshalFX

from OpenGL.GL import *

class Light:
    def __init__(self, **kwords):
        self.kwords = kwords

    def bind(self, i):
        for key,val in self.kwords.items():
            try:
                marshalFX(self, key, i, val)

            except AttributeError, e:
                print "Unknown light state: '%s'" % key

    def Ambient(self, l, val):
        glLightfv(l, GL_AMBIENT, val)

    def Attenuation0(self, l, val):
        glLightf(l, GL_CONSTANT_ATTENUATION, val);

    def Attenuation1(self, l, val):
        glLightf(l, GL_LINEAR_ATTENUATION, val);

    def Attenuation2(self, l, val):
        glLightf(l, GL_QUADRATIC_ATTENUATION, val);

    def Diffuse(self, l, val):
        glLightfv(l, GL_DIFFUSE, val)

    def Direction(self, l, val):
        glLightfv(l, GL_SPOT_DIRECTION, val)

    def Falloff(self, l, val):
        raise NotImplemented('Light::Falloff')

    def Phi(self, l, val):
        glLightf(l, GL_SPOT_CUTOFF, val*90/pi);

    def Position(self, l, val):
        glLightfv(l, GL_POSITION, val)

    def Range(self, l, val):
        raise NotImplemented('Light::Range')
    
    def Specular(self, l, val):
        glLightfv(l, GL_SPECULAR, val)

    def Theta(self, l, val):
        raise NotImplemented('Light::Theta')

    def Type(self, l, val):
        raise NotImplemented('Light::Type')
