
#======================================================================================#
# Copyright (C) 2004 Carl Johan Lejdfors                                               #
#                                                                                      #
# This program is free software; you can redistribute it and/or modify                 #
# it under the terms of the GNU General Public License as published by                 #
# the Free Software Foundation; either version 2 of the License, or                    #
# (at your option) any later version.                                                  #
#                                                                                      #
# This program is distributed in the hope that it will be useful,                      #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                       #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                        #
# GNU General Public License for more details.                                         #
#                                                                                      #
# You should have received a copy of the GNU General Public License                    #
# along with this program; if not, write to the Free Software                          #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            #
#                                                                                      #
# Please send all bugreports to: Carl Johan Lejdfors <calle.lejdfors@cs.lth.se>        #
#======================================================================================#

import RenderTexture as rt


class RenderTexture:
    """ Interface class to the SWIG of the RenderTexture class by Mark
        J. Harris """
    
    def __init__(self, width, height, depth = 8, useMipmaps = False):
        self.rt = rt.RenderTexture(width,height)
        self.rt.Initialize(True,
                           False,
                           False,
                           useMipmaps,
                           False,
                           True,
                           depth,
                           depth,
                           depth,
                           depth)
        #print "Initialize:", self.rt.Initialize()

    def bind(self, doBind = True):
        #print "** bind(", doBind, ") **"
        if self.rt.IsCapturing():
            #print "** |-> UpdateTexture() **"
            self.rt.UpdateTexture()

        if doBind:
            self.rt.Bind()
            self.rt.EnableTextureTarget()

    def textureId(self):
        return self.rt.GetTextureID()

    def size(self):
        return self.rt.GetWidth(),self.rt.GetHeight()

    def activate(self):
        #print "** BeginCapture() **"
        if not self.rt.BeginCapture():
            #print "** BeginCapture() ERROR! **"
            pass

    def deactivate(self):
        #print "** EndCapture() **"
        if not self.rt.EndCapture():
            #print "** EndCapture() ERROR! **"
            pass
                        

        
        
        
